diff --git a/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java b/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
index 03c85818c..f9acfa263 100644
--- a/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
@@ -1,23 +1,95 @@
 package net.minecraft.client.render;
 
-import java.util.*;
+import java.util.HashMap;
+import java.util.Map;
 
-import net.minecraft.client.Minecraft;
+import org.lwjgl.opengl.GL11;
+
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.ICamera;
-import net.minecraft.client.render.entity.*;
-import net.minecraft.client.render.model.*;
+import net.minecraft.client.render.entity.ArmoredZombieRenderer;
+import net.minecraft.client.render.entity.ArrowRenderer;
+import net.minecraft.client.render.entity.BoatRenderer;
+import net.minecraft.client.render.entity.BobberRenderer;
+import net.minecraft.client.render.entity.CannonballRenderer;
+import net.minecraft.client.render.entity.ChickenRenderer;
+import net.minecraft.client.render.entity.CowRenderer;
+import net.minecraft.client.render.entity.CreeperRenderer;
+import net.minecraft.client.render.entity.DefaultRenderer;
+import net.minecraft.client.render.entity.EntityRenderer;
+import net.minecraft.client.render.entity.FallingSandRenderer;
+import net.minecraft.client.render.entity.FireballRenderer;
+import net.minecraft.client.render.entity.FireflyRenderer;
+import net.minecraft.client.render.entity.GhastRenderer;
+import net.minecraft.client.render.entity.GiantRenderer;
+import net.minecraft.client.render.entity.ItemEntityRenderer;
+import net.minecraft.client.render.entity.LightningBoltRenderer;
+import net.minecraft.client.render.entity.LivingRenderer;
+import net.minecraft.client.render.entity.MinecartRenderer;
+import net.minecraft.client.render.entity.MobRenderer;
+import net.minecraft.client.render.entity.MonsterRenderer;
+import net.minecraft.client.render.entity.PaintingRenderer;
+import net.minecraft.client.render.entity.PigRenderer;
+import net.minecraft.client.render.entity.PlayerRenderer;
+import net.minecraft.client.render.entity.ScorpionRenderer;
+import net.minecraft.client.render.entity.SheepRenderer;
+import net.minecraft.client.render.entity.SlimeRenderer;
+import net.minecraft.client.render.entity.SnowballRenderer;
+import net.minecraft.client.render.entity.SpiderRenderer;
+import net.minecraft.client.render.entity.SquidRenderer;
+import net.minecraft.client.render.entity.TNTRenderer;
+import net.minecraft.client.render.entity.WolfRenderer;
+import net.minecraft.client.render.model.ModelBiped;
+import net.minecraft.client.render.model.ModelChicken;
+import net.minecraft.client.render.model.ModelCow;
+import net.minecraft.client.render.model.ModelPig;
+import net.minecraft.client.render.model.ModelSheep;
+import net.minecraft.client.render.model.ModelSheepOverlay;
+import net.minecraft.client.render.model.ModelSheepWool;
+import net.minecraft.client.render.model.ModelSkeleton;
+import net.minecraft.client.render.model.ModelSlime;
+import net.minecraft.client.render.model.ModelSquid;
+import net.minecraft.client.render.model.ModelWolf;
+import net.minecraft.client.render.model.ModelZombie;
 import net.minecraft.client.render.tessalator.Tessellator;
-import net.minecraft.core.entity.*;
-import net.minecraft.core.entity.animal.*;
-import net.minecraft.core.entity.monster.*;
+import net.minecraft.core.Global;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityBobber;
+import net.minecraft.core.entity.EntityFallingSand;
+import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.EntityLightningBolt;
+import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.EntityPainting;
+import net.minecraft.core.entity.EntityTNT;
+import net.minecraft.core.entity.animal.EntityChicken;
+import net.minecraft.core.entity.animal.EntityCow;
+import net.minecraft.core.entity.animal.EntityFireflyCluster;
+import net.minecraft.core.entity.animal.EntityPig;
+import net.minecraft.core.entity.animal.EntitySheep;
+import net.minecraft.core.entity.animal.EntitySquid;
+import net.minecraft.core.entity.animal.EntityWolf;
+import net.minecraft.core.entity.monster.EntityArmoredZombie;
+import net.minecraft.core.entity.monster.EntityCreeper;
+import net.minecraft.core.entity.monster.EntityGhast;
+import net.minecraft.core.entity.monster.EntityGiant;
+import net.minecraft.core.entity.monster.EntityHuman;
+import net.minecraft.core.entity.monster.EntityScorpion;
+import net.minecraft.core.entity.monster.EntitySkeleton;
+import net.minecraft.core.entity.monster.EntitySlime;
+import net.minecraft.core.entity.monster.EntitySnowman;
+import net.minecraft.core.entity.monster.EntitySpider;
+import net.minecraft.core.entity.monster.EntityZombie;
 import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.entity.projectile.*;
+import net.minecraft.core.entity.projectile.EntityArrow;
+import net.minecraft.core.entity.projectile.EntityCannonball;
+import net.minecraft.core.entity.projectile.EntityEgg;
+import net.minecraft.core.entity.projectile.EntityFireball;
+import net.minecraft.core.entity.projectile.EntityPebble;
+import net.minecraft.core.entity.projectile.EntitySnowball;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.world.World;
-import net.minecraft.client.option.GameSettings;
-import org.lwjgl.opengl.GL11;
 
 public class EntityRenderDispatcher
 {
@@ -103,9 +175,21 @@ public class EntityRenderDispatcher
         double lerpPosY = entity.yo + (entity.y - entity.yo) * (double)partialTick;
         double lerpPosZ = entity.zo + (entity.z - entity.zo) * (double)partialTick;
         float lerpYaw = entity.yRotO + (entity.yRot - entity.yRotO) * partialTick;
-        float brightness = entity.getBrightness(partialTick);
-        if (Minecraft.getMinecraft(this).fullbright) brightness = 1.0f;
+        float brightness;
+        
+        if(LightmapHelper.isLightmapEnabled()) {
+        	brightness = 1.0f;
+        	
+        	LightmapHelper.setLightmapCoord(entity.getLightmapCoord(partialTick));
+        }else if(Global.accessor.isFullbrightEnabled()) {
+        	brightness = 1.0f;
+        }else {
+        	brightness = entity.getBrightness(partialTick);
+        }
+        
+        if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
         GL11.glColor3f(brightness, brightness, brightness);
+        
         renderEntityWithPosYaw(tessellator, entity, lerpPosX - renderPosX, lerpPosY - renderPosY, lerpPosZ - renderPosZ, lerpYaw, partialTick);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/ItemRenderer.java b/src/main/java/net/minecraft/client/render/ItemRenderer.java
index fb43cd95c..2448bf04a 100644
--- a/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -85,9 +85,15 @@ public class ItemRenderer
             ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderItemFirstPerson(TessellatorStandard.instance,this, player, itemstack, partialTick);
         } else
         {
-            float brightness = mc.theWorld.getLightBrightness(MathHelper.floor_double(player.x), MathHelper.floor_double(player.y), MathHelper.floor_double(player.z));
-            if (mc.fullbright) brightness = 1.0f;
-            GL11.glColor4f(brightness, brightness, brightness, 1.0F);
+        	float brightness = 1.0f;
+        	if(LightmapHelper.isLightmapEnabled() || mc.fullbright) {
+        		LightmapHelper.setLightmapCoord(mc.thePlayer.getLightmapCoord(partialTick));
+        	}else if(mc.fullbright) {
+        		
+        	}else {
+        		brightness = mc.theWorld.getLightBrightness(MathHelper.floor_double(player.x), MathHelper.floor_double(player.y), MathHelper.floor_double(player.z));
+        	}
+            GL11.glColor4f(brightness, brightness, brightness, 1.0f);
             float f6 = 0.8F;
             float swingProgress = player.getSwingProgress(partialTick);
             float f14 = MathHelper.sin(swingProgress * MathHelper.PI);
diff --git a/src/main/java/net/minecraft/client/render/LightmapHelper.java b/src/main/java/net/minecraft/client/render/LightmapHelper.java
index 6be738409..eb29e66fb 100644
--- a/src/main/java/net/minecraft/client/render/LightmapHelper.java
+++ b/src/main/java/net/minecraft/client/render/LightmapHelper.java
@@ -115,6 +115,10 @@ public class LightmapHelper {
 			int light = Math.max(skyLight, blockLight);
 
 			float brightness = world.worldType.getBrightnessRamp()[light];
+			
+			brightness = applyGamma(brightness, mc.gameSettings.brightness.value - 0.5f);
+			
+			brightness = MathHelper.clamp(brightness, 0.0f, 1.0f);
 
 			int brightnessI = (int) (brightness * 255);
 
@@ -126,7 +130,7 @@ public class LightmapHelper {
 
 	public void generateVanillaLightmap(World world, float partialTicks) {
 		float ambientBrightness = world.getAmbientBrightness(partialTicks);
-		float brightness = 0.0f;
+		float brightness = mc.gameSettings.brightness.value - 0.5f;
 
 		for(int i = 0; i < 256; i++) {
 			float skyLight = getBrightnessRemoveMinLight(world, i / 16) * (ambientBrightness * 0.95f + 0.05f);
@@ -268,5 +272,24 @@ public class LightmapHelper {
 //		return (lmc01 + lmc23) >> 1;
 		return avg(avg(lmc0, lmc1), avg(lmc2, lmc3));
 	}
+	
+	public static void setLightmapCoord(int skylight, int blocklight) {
+		glMultiTexCoord2f(GL_TEXTURE1, blocklight * 16.0f, skylight * 16.0f);
+	}
+	
+	public static void setLightmapCoord(int lightmapCoord) {
+		int sky = lightmapCoord >> 16;
+		int block = lightmapCoord & 0xFFFF;
+		
+		glMultiTexCoord2f(GL_TEXTURE1, block, sky);
+	}
+	
+	public static int setBlocklightValue(int lightmapCoord, int blocklight) {
+		return lightmapCoord & 0xFFFF0000 | blocklight << 4;
+	}
+	
+	public static int setSkylightValue(int lightmapCoord, int skylight) {
+		return lightmapCoord & 0x0000FFFF | skylight << 20;
+	}
 
 }
diff --git a/src/main/java/net/minecraft/client/render/RenderBlockCache.java b/src/main/java/net/minecraft/client/render/RenderBlockCache.java
index abcf39cfc..123c7d1fb 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlockCache.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlockCache.java
@@ -1,12 +1,11 @@
 package net.minecraft.client.render;
 
+import java.util.Arrays;
+
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.world.WorldSource;
 
-import java.util.Arrays;
-
 final public class RenderBlockCache {
     private final Minecraft mc = Minecraft.getMinecraft(this);
     
@@ -41,33 +40,37 @@ final public class RenderBlockCache {
             offsetZ = z;
         }
     }
+    
+    private float calcBrightness(int x, int y, int z) {
+		float brightness = block.getBlockBrightness(access, x, y, z);
 
-	public float getBrightness(int relX, int relY, int relZ) {
-		int x1 = relX + offsetX;
-		int y1 = relY + offsetY;
-		int z1 = relZ + offsetZ;
-		
 		if(LightmapHelper.isLightmapEnabled() || mc.fullbright) {
-			Block block = access.getBlock(x1, y1, z1);
-			if(block == null) {
+			int lightEmission = Block.lightEmission[block.id];
+			if(lightEmission > 0) {
 				return 1.0f;
 			}
-			return 1.0f - block.getAmbientOcclusionStrength(access, x1, y1, z1);
-		}
-		
-		if(mc.isTreeShadingEnabled() && mc.isAmbientOcclusionEnabled()) {
-			if(access.getBlock(x1, y1, z1) instanceof BlockLeavesBase) {
-				float brightness = access.getBrightness(x1, y1, z1, Block.lightEmission[access.getBlockId(x1, y1, z1)]);
-				if(brightness > 0.2F) {
-					brightness = 0.2F;
-				}
-				return brightness;
+			if(!mc.isAmbientOcclusionEnabled()) {
+				return 1.0f;
+			}
+			Block block = access.getBlock(x, y, z);
+			if(block == null) {
+				return 1.0f;
 			}
+			return 1.0f - block.getAmbientOcclusionStrength(access, x, y, z);
 		}
 		
+		return brightness;
+    }
+    
+	public float getBrightness(int relX, int relY, int relZ) {
 		int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
+		
 		if(!brightnessCached[index]) {
-			brightnessValue[index] = block.getBlockBrightness(access, x1, y1, z1);
+			int x1 = relX + offsetX;
+			int y1 = relY + offsetY;
+			int z1 = relZ + offsetZ;
+			
+			brightnessValue[index] = calcBrightness(x1, y1, z1);
 			brightnessCached[index] = true;
 		}
 		
diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/src/main/java/net/minecraft/client/render/RenderBlocks.java
index e7c35ec0c..5f2030421 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -249,55 +249,57 @@ public class RenderBlocks
     	boolean ao = mc.isAmbientOcclusionEnabled();
         
     	if(LightmapHelper.isLightmapEnabled()) {
-    		int lmc;
     		if(overbright) {
 				// TODO use correct skylight value, requires a getSavedLightValue method in WorldSource
-    			lmc = LightmapHelper.getOverbrightLightmapCoord(0);
+    			int lmc = LightmapHelper.getOverbrightLightmapCoord(0);
+        		lightmapCoordTopLeft = lightmapCoordBottomLeft = lightmapCoordBottomRight = lightmapCoordTopRight = lmc;
     		}else {
-            	if(depth > FULL_CUBE_THRESHOLD) {
-            		lmc = block.getLightmapCoord(blockAccess, x, y, z);
-            	}else {
-            		lmc = block.getLightmapCoord(blockAccess, x + dirX, y + dirY, z + dirZ);
-            	}	
-    		}
-    		lightmapCoordTopLeft = lightmapCoordBottomLeft = lightmapCoordBottomRight = lightmapCoordTopRight = lmc;
-    		if(ao) {
-    			int dirX2 = dirX;
-    			int dirY2 = dirY;
-    			int dirZ2 = dirZ;
-    			
-    			if(depth > FULL_CUBE_THRESHOLD) {
-    				dirX2 = 0;
-    				dirY2 = 0;
-    				dirZ2 = 0;
-    			}
-    			
-    			boolean topT = cache.getOpacity(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
-    			boolean botT = cache.getOpacity(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
-    			boolean lefT = cache.getOpacity(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
-    			boolean rigT = cache.getOpacity(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
-    			
-    			boolean topLefT = cache.getOpacity(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ);
-    			boolean topRigT = cache.getOpacity(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ);
-    			boolean botLefT = cache.getOpacity(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ);
-    			boolean botRigT = cache.getOpacity(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ);
-    			
-    			int lmcCen = cache.getLightmapCoord(dirX2, dirY2, dirZ2);
-    			
-    			int lmcTop = topT ? lmcCen : cache.getLightmapCoord(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
-    			int lmcBot = botT ? lmcCen : cache.getLightmapCoord(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
-    			int lmcLef = lefT ? lmcCen : cache.getLightmapCoord(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
-    			int lmcRig = rigT ? lmcCen : cache.getLightmapCoord(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
+        		if(ao) {
+        			int dirX2 = dirX;
+        			int dirY2 = dirY;
+        			int dirZ2 = dirZ;
+        			
+        			if(depth > FULL_CUBE_THRESHOLD) {
+        				dirX2 = 0;
+        				dirY2 = 0;
+        				dirZ2 = 0;
+        			}
+        			
+        			boolean topT = cache.getOpacity(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
+        			boolean botT = cache.getOpacity(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
+        			boolean lefT = cache.getOpacity(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
+        			boolean rigT = cache.getOpacity(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
+        			
+        			boolean topLefT = cache.getOpacity(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ);
+        			boolean topRigT = cache.getOpacity(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ);
+        			boolean botLefT = cache.getOpacity(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ);
+        			boolean botRigT = cache.getOpacity(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ);
+        			
+        			int lmcCen = cache.getLightmapCoord(dirX2, dirY2, dirZ2);
+        			
+        			int lmcTop = topT ? lmcCen : cache.getLightmapCoord(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
+        			int lmcBot = botT ? lmcCen : cache.getLightmapCoord(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
+        			int lmcLef = lefT ? lmcCen : cache.getLightmapCoord(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
+        			int lmcRig = rigT ? lmcCen : cache.getLightmapCoord(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
 
-    			int lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : cache.getLightmapCoord(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ));
-    			int lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : cache.getLightmapCoord(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ));
-    			int lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : cache.getLightmapCoord(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ));
-    			int lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : cache.getLightmapCoord(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ));
+        			int lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : cache.getLightmapCoord(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ));
+        			int lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : cache.getLightmapCoord(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ));
+        			int lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : cache.getLightmapCoord(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ));
+        			int lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : cache.getLightmapCoord(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ));
 
-    			lightmapCoordTopLeft     = LightmapHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
-    			lightmapCoordTopRight    = LightmapHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
-    			lightmapCoordBottomLeft  = LightmapHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
-    			lightmapCoordBottomRight = LightmapHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
+        			lightmapCoordTopLeft     = LightmapHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
+        			lightmapCoordTopRight    = LightmapHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
+        			lightmapCoordBottomLeft  = LightmapHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
+        			lightmapCoordBottomRight = LightmapHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
+        		}else {
+        			int lmc;
+                	if(depth > FULL_CUBE_THRESHOLD) {
+                		lmc = block.getLightmapCoord(blockAccess, x, y, z);
+                	}else {
+                		lmc = block.getLightmapCoord(blockAccess, x + dirX, y + dirY, z + dirZ);
+                	}
+            		lightmapCoordTopLeft = lightmapCoordBottomLeft = lightmapCoordBottomRight = lightmapCoordTopRight = lmc;
+        		}
     		}
     	}
     	
@@ -476,7 +478,6 @@ public class RenderBlocks
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
         } else
         {
-        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
@@ -564,7 +565,6 @@ public class RenderBlocks
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
         } else
         {
-        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
@@ -658,7 +658,6 @@ public class RenderBlocks
             tessellator.addVertexWithUV(d12, d14, d16, d4, d6);
         } else
         {
-        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.addVertexWithUV(d12, d15, d16, d8, d10);
             tessellator.addVertexWithUV(d13, d15, d16, d3, d5);
             tessellator.addVertexWithUV(d13, d14, d16, d9, d11);
@@ -752,7 +751,6 @@ public class RenderBlocks
             tessellator.addVertexWithUV(x1, y1, z0, d8, d10);
         } else
         {
-        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.addVertexWithUV(x0, y1, z0, d3, d5);
             tessellator.addVertexWithUV(x0, y0, z0, d9, d11);
             tessellator.addVertexWithUV(x1, y0, z0, d4, d6);
@@ -848,7 +846,6 @@ public class RenderBlocks
             tessellator.addVertexWithUV(d12, d13, d16, d4, d6);
         } else
         {
-        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.addVertexWithUV(d12, d14, d16, d8, d10);
             tessellator.addVertexWithUV(d12, d14, d15, d3, d5);
             tessellator.addVertexWithUV(d12, d13, d15, d9, d11);
@@ -943,7 +940,6 @@ public class RenderBlocks
             tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMin);
         } else
         {
-        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
             tessellator.addVertexWithUV(xMax, yMin, zMax, uMin2, vMax2);
             tessellator.addVertexWithUV(xMax, yMin, zMin, uMax, vMax);
             tessellator.addVertexWithUV(xMax, yMax, zMin, uMax2, vMin2);
diff --git a/src/main/java/net/minecraft/client/render/Scissor.java b/src/main/java/net/minecraft/client/render/Scissor.java
index 04ef49b10..98ce7458f 100644
--- a/src/main/java/net/minecraft/client/render/Scissor.java
+++ b/src/main/java/net/minecraft/client/render/Scissor.java
@@ -7,8 +7,10 @@ import org.lwjgl.opengl.GL11;
 import static org.lwjgl.opengl.GL11.GL_SCISSOR_TEST;
 
 public abstract class Scissor {
+	private static Minecraft mc = Minecraft.getMinecraft(Scissor.class);
+	
     public static void enable(int x, int y, int xSize, int ySize) {
-        GameResolution resolution = Minecraft.getMinecraft(Scissor.class).resolution;
+        GameResolution resolution = mc.resolution;
         int xScaled = x * resolution.scale;
         int yScaled = resolution.height - ((y + ySize) * resolution.scale);
         int xSizeScaled = xSize * resolution.scale;
diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 52c76cafb..b067277c9 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -393,7 +393,9 @@ public class WorldRenderer
         }
         if(mc.gameSettings.thirdPersonView.value == 0 && !(mc.currentScreen instanceof GuiPhotoMode) && !(!(mc.activeCamera instanceof EntityCamera) || ((EntityCamera) mc.activeCamera).entity.isPlayerSleeping()) && mc.gameSettings.immersiveMode.drawHand())
         {
+            lightmapHelper.enableLightmapRendering();
             if(!zooming) itemRenderer.renderItemInFirstPerson(partialTick);
+            lightmapHelper.disableLightmapRendering();
         }
         GL11.glPopMatrix();
         if(mc.gameSettings.thirdPersonView.value == 0 && !(!(mc.activeCamera instanceof EntityCamera) || ((EntityCamera) mc.activeCamera).entity.isPlayerSleeping()))
@@ -677,7 +679,6 @@ public class WorldRenderer
         Debug.change("terrain");
         lightmapHelper.enableLightmapRendering();
         renderGlobal.sortAndRender(mc.activeCamera, 0, partialTick);
-        lightmapHelper.disableLightmapRendering();
 
         Debug.change("entities");
         GL11.glShadeModel(7424 /*GL_FLAT*/);
@@ -698,6 +699,8 @@ public class WorldRenderer
         fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTick);
         effectRenderer.renderParticles(mc.activeCamera, partialTick);
 
+        lightmapHelper.disableLightmapRendering();
+        
         Debug.change("outline");
         if(mc.objectMouseOver != null)
         {
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
index 83103fa06..100362b2c 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
@@ -7,10 +7,12 @@ import net.minecraft.core.world.WorldSource;
 public class BlockColorWater
     extends BlockColor
 {
+	private final Minecraft mc = Minecraft.getMinecraft(this);
+	
     @Override
     public int getFallbackColor(int meta)
     {
-        if (Minecraft.getMinecraft(this).gameSettings.biomeWater.value)
+        if (mc.gameSettings.biomeWater.value)
         {
             return ColorizerWater.getWaterColor(0.5, 0.5);
         }
@@ -22,7 +24,7 @@ public class BlockColorWater
     public int getWorldColor(WorldSource world, int x, int y, int z)
     {
         if (world != null) {
-            if (Minecraft.getMinecraft(this).gameSettings.biomeWater.value)
+            if (mc.gameSettings.biomeWater.value)
             {
                 double temp = world.getBlockTemperature(x, z);
                 double hum = world.getBlockHumidity(x, z);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
index a493c0a0b..1f743beba 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockFire;
@@ -25,7 +26,13 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T>{
         {
             tex = renderBlocks.overrideBlockTexture;
         }
-        float brightness = renderBlocks.getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	// TODO skylight
+        	tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(0));
+        }else {
+        	brightness = renderBlocks.getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
         double uMin = tex.getIconUMin();
         double uMax = tex.getIconUMax();
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinPie.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinPie.java
index ad91d66e4..5fa45ba6d 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinPie.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinPie.java
@@ -15,6 +15,9 @@ public class BlockModelPumpkinPie<T extends Block> extends BlockModelStandard<T>
 
     public BlockModelPumpkinPie(Block block) {
         super(block);
+        float f = 0.0625F;
+        float f1 = 0.375F;
+        withCustomItemBounds(f, 0.0F, f, 1.0F - f, f1, 1.0F - f);
     }
 
     public void renderSliceSide(Tessellator tessellator, Block block, int x, int y, int z, Side side, boolean overrideTex) {
@@ -77,10 +80,6 @@ public class BlockModelPumpkinPie<T extends Block> extends BlockModelStandard<T>
         renderBlocks.enableAO = false;
         return true;
     }
-    @Override
-    public boolean shouldItemRender3d() {
-        return false;
-    }
 
     public int maxSlices;
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
index c956b6df2..0ea591b0b 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
@@ -39,7 +40,7 @@ public class BlockModelStandard<T extends Block> extends BlockModel<T>{
             GL11.glColor4f(brightness, brightness, brightness, alpha);
         }
         float yOffset = 0.5F;
-
+        
         setBlockBoundsForItemRender();
         GL11.glTranslatef(-0.5F, 0.0F - yOffset, -0.5F);
 
diff --git a/src/main/java/net/minecraft/client/render/colorizer/ColorizerWater.java b/src/main/java/net/minecraft/client/render/colorizer/ColorizerWater.java
index 26775f279..49fbcae1b 100644
--- a/src/main/java/net/minecraft/client/render/colorizer/ColorizerWater.java
+++ b/src/main/java/net/minecraft/client/render/colorizer/ColorizerWater.java
@@ -5,6 +5,7 @@ import net.minecraft.core.world.Dimension;
 
 public class ColorizerWater {
 
+	private static Minecraft mc = Minecraft.getMinecraft(ColorizerWater.class);
 	private static int colorData[] = new int[65536];
 
 	public static void updateColorData(int[] colorData) {
@@ -13,9 +14,9 @@ public class ColorizerWater {
 
 	public static int getWaterColor(double temperature, double humidity) {
 		try {
-			if (Minecraft.getMinecraft(ColorizerWater.class).gameSettings.biomeWater.value) {
+			if (mc.gameSettings.biomeWater.value) {
 
-				if(Minecraft.getMinecraft(ColorizerWater.class).theWorld.dimension == Dimension.nether){
+				if(mc.theWorld.dimension == Dimension.nether){
 					return 0XF54242;
 				}
 
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
index a8b13db57..049c77706 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
@@ -1,12 +1,12 @@
 package net.minecraft.client.render.dynamictexture;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.block.model.BlockModelStandard;
-import net.minecraft.client.render.stitcher.AtlasStitcher;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 
 public class DynamicTextureWaterFlow extends DynamicTexture {
-
+	
+	private final Minecraft mc = Minecraft.getMinecraft(this);
+	
 	private float[] arr1;
 	private float[] arr2;
 	private float[] arr3;
@@ -75,7 +75,7 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 			int b = 255;
 			int a = (int) (146.0F + var13 * 50.0F);
 
-			if (Minecraft.getMinecraft(this).gameSettings.biomeWater.value) {
+			if (mc.gameSettings.biomeWater.value) {
 				r = g = b = (r + g + b) / 3;
 			}
 
